/***************************************************************************
                           m_chghost.c
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "handlers.h"
#include "client.h"
#include "hash.h" /* due to beta9 changes ... comment this out for beta7 servers */
#include "common.h"     /* FALSE bleah */
#include "ircd.h"
#include "irc_string.h"
#include "numeric.h"
#include "fdlist.h"
#include "s_bsd.h"
#include "s_conf.h"
#include "s_log.h"
#include "s_serv.h"
#include "send.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"
#include "whowas.h"
#include <string.h>

static void ms_chghost( struct Client *client_p, struct Client *source_p,
			int parc, char *parv[] );

struct Message chghost_msgtab = {
  "CHGHOST", 0, 3, 3, 0, MFLG_SLOW, 0,
  /* uncomment this if you use beta 9 hybird ircd */
  /*   "CHGHOST", 0, 3, 3, MFLG_SLOW, 0 */
  { m_ignore, m_ignore, ms_chghost, m_ignore }
};

void _modinit(void) 
{
  mod_add_cmd(&chghost_msgtab);
}

void _moddeinit(void)
{
  mod_del_cmd(&chghost_msgtab);
}

char *_version = "20020401";

static void ms_chghost(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
{
  struct Client *target=NULL;
  dlink_node    *ptr       = NULL;
  struct Client *bclient_p = NULL;
  
  if( IsServer( source_p ) && MyConnect( source_p ) )
    {
      /* this is the version for beta 7 servers */
/*       if( !(target = find_client( parv[1], NULL ) ) ) { */
      if( !(target = find_client( parv[1] ) ) ) {
	/* 
	 * chasing client now 
	 * dont know which timeout to use... *shame*
	 */
	if( !(target = get_history( parv[1], (long) KILLCHASETIMELIMIT ) ) ) 
	  {
	    sendto_one( client_p, form_str( ERR_NOSUCHNICK ),
			me.name, parv[0], parv[1] );
	    return;
	  }
      }

      if( !strcmp( target->host, parv[2] ) ) return;
      
      strcpy( target->host, parv[2] );
      
      for( ptr = serv_list.head; ptr; ptr = ptr->next ) 
	{
	  bclient_p = ptr->data;
	  if( bclient_p == source_p ) continue;
	  
	  sendto_one( bclient_p, ":%s CHGHOST %s %s", me.name, parv[1],
		      target->host );
	}
    }
}
