/***************************************************************************
                           configfile.hpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: configfile.hpp,v 1.6 2002/03/09 12:49:34 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CONFIGFILE_HPP
#define _CONFIGFILE_HPP

class ConfigFile;
#include <configfileparser.hpp>
#include <config.h>

using namespace std;

class ConfigFile : protected ConfigFileParser {
public:
  ConfigFile();
  ConfigFile(const string &delim, char quoteChar = '#' );
  virtual ~ConfigFile();
  void setFilename(const string &newFilename) { filename=newFilename; };
  void process(const string &fname);
  void serialize( );
  const string &getFilename() { return filename; };
  
protected:
  virtual void onParsedLine(const string &l, const string &r);
  virtual void onParsedEntry(const string &key, const string &val)=0;

  // writing into buf will not result in overwriting values in configfile
  virtual void onSerialize( streambuf *buf ) = 0;
  virtual bool isOutQuoted(const string &row) const;
  void minimize(string &min, const string &max) const;
  
  string filename;
  char quoteChar;
  static const string STD_DIV; 

private:
  const ConfigFile & operator=(const ConfigFile &);
  ConfigFile(const ConfigFile &);
};

#endif
