/***************************************************************************
                           configfileparser.hpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net
    
    $Id: configfileparser.hpp,v 1.3 2002/03/09 12:49:34 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CONFIGFILEPARSER_HPP
#define _CONFIGFILEPARSER_HPP

#include <string>
#include <config.h>

using namespace std;

class ConfigFileParser {
public:
  ConfigFileParser(const string &lrDiv, const string &outQuoteString);
  ConfigFileParser(const string &lrDiv, const char *outQuoteChars="#");
  virtual ~ConfigFileParser();
  

protected:
  void parse(streambuf *buf);
  virtual void onParsedLine(const string&, const string&)=0;
  virtual void onParserError(const string &row) 
  {};
  virtual bool isOutQuoted(const string &row) const =0;
  
  string lrdelim;
  
private:
  bool seperateLR(string &l, string &r, const string &row);
  ConfigFileParser();
  ConfigFileParser(const ConfigFileParser &);
  const ConfigFileParser & operator = (const ConfigFileParser &);
};

#endif
