/***************************************************************************
                           debug.hpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: debug.hpp,v 1.6 2002/03/20 16:45:36 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEBUG_HPP
#define DEBUG_HPP

#include "config.h"

#ifdef VERBOSE_TIMESTATS
extern "C"  {
#include <sys/time.h>
}
#endif

#define PRINT_FATAL_ERROR(quit) \
   cerr << "HostServ] cought fatal error: " \
	<< __FILE__ << ':' << __LINE__ << endl; \
   if( quit ) \
      exit( 1 ); \

// TIME PRINTING 

#ifdef VERBOSE_TIMESTATS

# define TIME_PRINT(out) out << ( __end_.tv_sec - __start_.tv_sec ) << "s "  \
                                   << ( __end_.tv_usec - __start_.tv_usec ) << "ms" << endl
# define TIME_INIT() timeval __start_, __end_
# define TIME_START() gettimeofday( &__start_, NULL )
# define TIME_STOP() gettimeofday( &__end_, NULL )

#else

# define TIME_PRINT(x);
# define TIME_INIT();
# define TIME_START();
# define TIME_STOP();

#endif

#endif
