/***************************************************************************
                           dereferencecomparator.hpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: dereferencecomparator.hpp,v 1.5 2002/03/19 10:58:10 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _DEREFERENCE_LESS
#define _DEREFERENCE_LESS

using namespace std;

template <typename T>
struct DereferenceLess : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs < *rhs ; };
};

template <typename T>
struct DereferenceEqual : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs == *rhs ; };
};

template <typename T>
struct DereferenceMore : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs > *rhs ; };
};

template<typename T>
class DereferenceEqualPredicate {
public:
  DereferenceEqualPredicate( T& t )
    : m_t( t )
  {}
  
  bool operator()( T& t )
  { return *m_t == *t; }

private:
  T& m_t;
};
#endif
