/***************************************************************************
                           entitybody.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: entitybody.hpp,v 1.3 2002/05/25 16:15:36 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef ENTITYBODY_HPP
#define ENTITYBODY_HPP

#include <iostream>
#include <fstream>
#include "http_common.hpp"
#include "httpstring.hpp"

namespace httpd
{  
  class ReadOnlyEntityBody
  {
  public:
    /**
     * read only entities do not get changed by reading them
     * ( at least concerning the content ).<br>
     * Therefore this function is a constant one.
     */
    virtual std::istream& getEntityInputStream() const = 0;
  };

  class ReadOnlyFileEntityBody : public ReadOnlyEntityBody
  {
  public:
    explicit ReadOnlyFileEntityBody( const http::HTTPString& filename )
      : m_ifstream( (const char*)filename.c_str(), std::ios::in )
    {}
    
    virtual ~ReadOnlyFileEntityBody()
    {}

    virtual std::istream& getEntityInputStream() const
    { return m_ifstream; }

  private:
    mutable std::ifstream m_ifstream;
  };

}//EON EntityBody
#endif
