#include "responsesetting.hpp"
#include "http_common.hpp"
#include "messageheader.hpp"

namespace httpd
{

class FileResponseSetting : public ResponseSetting
{
public:
  static const FileResponseSetting& getFileResponseSetting( const http::HTTPString& requestDocument,
						     http::httpprotversion_type protocolVersion,
						     bool& defaultValueUsed );

  FileResponseSetting( const http::HTTPString& fileTypeString,
		       connection_type connection,
		       bodyencoding_type bodyEncoding,
		       bool hssScript = false )
    : ResponseSetting( connection, bodyEncoding ),
      m_contentTypeHeader( http::ENT_CONTENT_TYPE, fileTypeString ),
      m_hssScript( hssScript )
  {}

//   FileResponseSetting( const FileResponseSetting& setting )
//     : ResponseSetting( setting ),
//       m_contentTypeHeader( setting.m_contentTypeHeader ),
//       m_hssScript( setting.m_hssScript )
//   {}

  virtual ~FileResponseSetting()
  {}


  const http::MessageHeader& getContentTypeHeader() const
  { return m_contentTypeHeader; }

  bool isHSSScript() const
  { return m_hssScript; }

private:
  http::MessageHeader m_contentTypeHeader;
  bool                m_hssScript;
  
};

}
