/***************************************************************************
                           hsclientconfigfile.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: hsclientconfigfile.hpp,v 1.6 2002/03/19 10:58:10 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _HSCLIENTCONFIGFILE_HPP
#define _HSCLIENTCONFIGFILE_HPP

#include "configfile.hpp"
#include "vhostlist.hpp"
#include "hsclientlist.hpp"
#include <config.h>

/**
 * a typical configfile entry looks like this:
 * '<username>':'<password>'|'<flags>'->'<vhost>'
 * '->[vhost]' is optional.
 */

using namespace std;

// FIXME: remove memory leaks on serialization
class HSClientConfigFile : public ConfigFile {
public:
  HSClientConfigFile( HSClientList *c, const VHostList *v );
  virtual ~HSClientConfigFile();
  
protected:
  virtual void onParsedEntry( const string &l, const string &r );
  virtual void onSerialize( streambuf *buf );
  
private:
  HSClientConfigFile( );
  HSClientConfigFile( const HSClientConfigFile & c );
  const HSClientConfigFile & operator = ( const HSClientConfigFile & );

  void writeClients( ostream& o, 
		     HSClientList* newClients,
		     const VHostList* vhosts );

  static const string DEF_DELIM;
  static const string FLAGS_VHOST_DELIM;
  static const string PASSWORD_FLAGS_DELIM;

  HSClientList*    m_clients;
  const VHostList* m_vhosts;

  class Writer {
    ostream&               m_out;
    const VHostList* const m_vhosts;

  public:
    Writer( ostream &o, const VHostList* vhosts );
    void operator() ( const HSClient* h );
		      
  };
};

#endif
