/***************************************************************************
                           hsconfigfile.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net

    $Id: hsconfigfile.hpp,v 1.14 2002/04/09 19:32:54 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _HSCONFIGFILE_HPP
#define _HSCONFIGFILE_HPP

#include <string>
#include <map>
#include <configfile.hpp>
#include <config.h>

using namespace std;

// fixme: !remove the default ctor and write another one which expects
//        a ConfigMap object as argument!
class HSConfigFile : public ConfigFile, public map<const string, string> {
  static const string DEF_DELIM;
  
public:
  typedef map<const string, string> ConfigMap;
  
  HSConfigFile();
  virtual ~HSConfigFile();
  bool isSet( const string &entryName ) const;
  
  // configuration directives
  const static string SERVER_NAME;
  const static string SERVER_DESCRIPTION;
  const static string REMOTE_SERVERNAME;
  const static string REMOTE_PASSWORD;
  const static string REMOTE_PORT;
  const static string HOSTSERV_NICK;
  const static string HOSTSERV_USERNAME;
  const static string HOSTSERV_ADDRESS;
  const static string HOSTSERV_REALNAME;
  const static string HOSTSERV_MODES;
  const static string HOSTSERV_CHANNEL;
  const static string HSCLIENT_DEFAULTPERMISSIONS;
  const static string VHOST_PUBLICPOLICY;
  const static string VHOSTS_CONFIGFILENAME;
  const static string USERS_CONFIGFILENAME;
  const static string HOSTSERV_CONFIGFILENAME;
  const static string ADMIN_LOGIN;
  const static string ADMIN_PASSWORD;
  const static string ADMIN_VHOST;
  const static string HTTPD_IF;
  const static string HTTPD_PORT;
  const static string HTTPD_MAXCLIENTS;
  const static string HTTPD_DOCUMENTROOT;
  const static string HTTPD_DEFAULTDOCUMENT;
  const static string HTTPD_MAX_CLIENT_TIMEOUT;

protected:
  virtual void onParsedEntry( const string &l, const string &r );
  virtual void onSerialize( streambuf *b )
  {}

private:
  HSConfigFile( const HSConfigFile &);
  const HSConfigFile & operator= ( const HSConfigFile & );
};


#endif
