/***************************************************************************
                           inethostaddress.hpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: inethostaddress.hpp,v 1.7 2002/05/25 16:15:36 d3cline Exp $
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _INETHOSTADDRESS_HPP
#define _INETHOSTADDRESS_HPP

#include <string>
extern "C" {
#include <netdb.h>
}

/**
 * represents an inet address
 */
class InetHostAddress {
public:
  InetHostAddress();
  InetHostAddress(const char *name);
  InetHostAddress(const std::string &name);

  /**
   * gather name lookup information
   * @return name not resolvable / no address resolved.
   */
  bool operator! () const;
    
  /**
   * gather name lookup information
   * behaves dual to 
   * @see #operator!
   */
  operator void*() const;
    
  const InetHostAddress & operator=(const char *name);
  const InetHostAddress & operator=(const std::string &name);

  /**
   * get canonical name for hostaddress
   * @return string containing canonical name for address
   */
  const char * getName() 
  {
    if(he) return he->h_name;
    else return NULL;
  }  
    
  const hostent * getHostent() const { return he; };
    
private:
  void init(const char *inetName);
  hostent *he;
};


std::ostream& operator<< (std::ostream &, const InetHostAddress &addr);

#endif
