/***************************************************************************
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: irc.hpp,v 1.14 2002/05/25 16:15:36 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 * 
 ***************************************************************************/

#ifndef IRC_HPP
#define IRC_HPP


#include "irctoken.hpp"

/**
 * removed duplicate wildcards
 */
IRCToken& collapse( IRCToken& );

/**
 * @param criteria a collapse()'d string
 * @param target IRCToken which gets compared with criteria
 */
bool match( const IRCToken& criteria, const IRCToken& target );

/**
 * @return number of skipped characters
 */
IRCToken::size_type toValidNickname( IRCToken& rawNick );
IRCToken::size_type toValidUsername( IRCToken& rawUsername );
IRCToken::size_type toValidHostname( IRCToken& rawHostname );
IRCToken::size_type toValidChanname( IRCToken& rawChanname );
IRCToken::size_type toValidHSClientString( IRCToken& str );

std::string::size_type toValidNickname( std::string& rawNick );
std::string::size_type toValidUsername( std::string& rawUsername );
std::string::size_type toValidHostname( std::string& rawHostname );
std::string::size_type toValidChanname( std::string& rawChanname );
std::string::size_type toValidHSClientString( std::string& str );

std::ostream& bold( std::ostream& o );
std::ostream& underlined( std::ostream& o );

#endif
