/***************************************************************************
                           ircmessagetokenizer.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: ircmessagetokenizer.hpp,v 1.7 2002/03/09 12:49:34 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef IRCMESSAGETOKENIZER_HPP
#define IRCMESSAGETOKENIZER_HPP

#include "irctokenizer.hpp"
#include "ircmessage.hpp"

/**
 * this class is used to parse a complete irc message
 *
 */
class IRCMessageTokenizer : protected IRCTokenizer
{
public:
  typedef IRCToken::size_type      len_type;
  typedef IRCToken::reference_type reference_type;
  typedef IRCToken::data_type      data_type;
  typedef int                      int_type;

  /**
   * @numMsgTokens the number of tokens which should be parsed
   *  out of the last token of the message
   */
  IRCMessageTokenizer( int numMsgTokens );

  /**
   * toknizes a given range of a char array
   * @return the number of parsed bytes<br>
   *  <b>note</b>: the return value will always point to the occurance
   *  of the delimiter. '\n' in this case.
   */
  int_type update( reference_type buf, len_type length );

  /**
   * @return the last tokenized ircmessage
   */
  const IRCServerMessage& getMessage()
  { return m_lastMessage; }

private:
  Tokenizer        m_msgTokenizer;
  IRCServerMessage m_lastMessage;
};

#endif
