/***************************************************************************
                           pollable.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: pollable.hpp,v 1.4 2002/03/09 12:49:34 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef POLLABLE_HPP
#define POLLABLE_HPP

#include "file.hpp"

class PollerClient;
class Poller;

class Pollable 
{
public:
  // ok this is _extremly_ ugly.
  friend class PollerClient;
  friend class Poller;

  virtual const File* getPollableFile() const = 0;

protected:
  virtual void onInput()        = 0;
  virtual void onOutput()       = 0;
  virtual void onError()        = 0;
  virtual void onHangup()       = 0;
  virtual void onRemoved()      = 0;
};

#endif
