/***************************************************************************
                           file.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: responsesetting.hpp,v 1.2 2002/05/16 17:50:24 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *
 ***************************************************************************/

#ifndef RESPONSESETTING_HPP
#define RESPONSESETTING_HPP

#include "response.hpp"
#include "http_common.hpp"

namespace httpd
{

class ResponseSetting
{
public:
  typedef Response::connection_type connection_type;
  typedef Response::bodyencoding_type bodyencoding_type;

  explicit ResponseSetting( connection_type connection, 
			    bodyencoding_type bodyEncoding )
    : m_connection( connection ),
      m_bodyEncoding( bodyEncoding )
  {}

  virtual ~ResponseSetting()
  {}

  void applySettingsTo( Response* response ) const
  { 
    response->setResponseBodyEncoding( m_bodyEncoding );
    response->setConnectionType( m_connection );
  }

  void setConnectiontype( connection_type connection )
  { m_connection = connection; }

  void setBodyEncoding( bodyencoding_type bodyEncoding )
  { m_bodyEncoding = bodyEncoding; }

  connection_type getConnectionType() const
  { return m_connection; }

  bodyencoding_type getBodyEncodingType() const
  { return m_bodyEncoding; }

private:
  connection_type   m_connection;
  bodyencoding_type m_bodyEncoding;
};

}//EON httpd

#endif
