/***************************************************************************
                           vhostconfigfile.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net

    $Id: vhostconfigfile.hpp,v 1.9 2002/04/09 19:32:55 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _VHOSTCONFIGFILE_HPP
#define _VHOSTCONFIGFILE_HPP

#include <configfile.hpp>
#include <vhostlist.hpp>
#include <config.h>

/**
 * format: [<1|0>::][<ident>]@<vhost>
 *
 */
class VHostConfigFile : public ConfigFile {
  VHostList* vhosts;
  static const string DEF_DELIM;
  static const string DEF_PUBLIC_USERNAME_DELIM;
  
public:
  VHostConfigFile( VHostList* v );
  virtual ~VHostConfigFile();
  VHostList* getVHosts()
  { return vhosts; };

protected:
  virtual void onParsedEntry( const string& l, const string& r );
  virtual void onSerialize( streambuf* buf );

private:
  void writeVHosts( ostream& o, 
		    VHostList *newVHosts );

  VHostConfigFile( );
  VHostConfigFile( const VHostConfigFile & );
  const VHostConfigFile& operator = ( const VHostConfigFile& );

  /** 
   * stl functor with delayed flushing
   */
  class Writer {
    ostream &out;

  public:
    Writer( ostream &o ) 
       : out( o )
    {};
    virtual ~Writer()
    { out.flush(); };
    void operator() ( const VHostList::storage_type& );
  };
};

#endif
