/***************************************************************************
                           configfileparser.cpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: configfileparser.cpp,v 1.5 2002/03/09 17:22:30 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <configfileparser.hpp>
#include <iostream>

ConfigFileParser::ConfigFileParser(const string &LRDiv, const string &qs)
  : lrdelim(LRDiv)
{  
#ifdef VERBOSE_MEMORY
  cout << "ConfigFileParser] created" << endl;
#endif
}

ConfigFileParser::ConfigFileParser(const string &LRDiv, const char* qs)
  : lrdelim(LRDiv)
{
#ifdef VERBOSE_MEMORY
  cout << "ConfigFileParser] created" << endl;
#endif
}

ConfigFileParser::~ConfigFileParser()
{
#ifdef VERBOSE_MEMORY
  cout << "ConfigFileParser] destroyed" << endl;
#endif
}

void ConfigFileParser::parse(streambuf *buf)
{
  string row; 
  string l, r;

  istream in(buf);
  while(getline(in,row)) {
    if( !isOutQuoted(row) )
    { 
       if( seperateLR(l,r,row) )
	  onParsedLine(l,r);
       else
	  onParserError(row);
    }
    else 
      onParserError(row);

    l.erase();
    r.erase();
    row.erase();
  }
}

bool ConfigFileParser::seperateLR(string &l, string &r, const string &row)
{
  string::size_type idx=row.find(lrdelim);
  if(idx==string::npos) return false;
  
  l=row.substr(0, idx);
  r=row.substr(idx+lrdelim.length());
  return true;
}
