/***************************************************************************
                           hsconfigfile.cpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: hsconfigfile.cpp,v 1.17 2002/04/09 19:32:55 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <hsconfigfile.hpp>
#include <algorithm>
#include <iostream>

const string HSConfigFile::SERVER_NAME           = "HostServServer.IRCName";
const string HSConfigFile::SERVER_DESCRIPTION    = "HostServServer.Description";
const string HSConfigFile::REMOTE_SERVERNAME     = "RemoteServer.Address";
const string HSConfigFile::REMOTE_PASSWORD       = "RemoteServer.Password";
const string HSConfigFile::REMOTE_PORT           = "RemoteServer.Port";
const string HSConfigFile::HOSTSERV_NICK         = "HostServ.Nick";
const string HSConfigFile::HOSTSERV_USERNAME     = "HostServ.Username";
const string HSConfigFile::HOSTSERV_ADDRESS      = "HostServ.Address";
const string HSConfigFile::HOSTSERV_REALNAME     = "HostServ.Realname";
const string HSConfigFile::HOSTSERV_MODES        = "HostServ.Modes";
const string HSConfigFile::HOSTSERV_CHANNEL      = "HostServ.Channel";
const string HSConfigFile::HSCLIENT_DEFAULTPERMISSIONS  = "Clients.DefaultUsermodes";
const string HSConfigFile::VHOST_PUBLICPOLICY    = "VHosts.PublicPolicy";
const string HSConfigFile::VHOSTS_CONFIGFILENAME = "VHosts.configfilename";
const string HSConfigFile::USERS_CONFIGFILENAME  = "Clients.configfilename";
const string HSConfigFile::HOSTSERV_CONFIGFILENAME = "Hostserv.configfilename";
const string HSConfigFile::ADMIN_LOGIN           = "Admin.Login";
const string HSConfigFile::ADMIN_PASSWORD        = "Admin.Password";
const string HSConfigFile::ADMIN_VHOST           = "Admin.VHost";
const string HSConfigFile::HTTPD_IF              = "HTTPd.BindIP";
const string HSConfigFile::HTTPD_PORT            = "HTTPd.Port";
const string HSConfigFile::HTTPD_MAXCLIENTS      = "HTTPd.MaxClients";
const string HSConfigFile::HTTPD_DOCUMENTROOT    = "HTTPd.DocumentRoot";
const string HSConfigFile::HTTPD_DEFAULTDOCUMENT = "HTTPd.DefaultDocument";
const string HSConfigFile::HTTPD_MAX_CLIENT_TIMEOUT = "HTTPd.MaxClientTimeout";

HSConfigFile::HSConfigFile( ) 
   : ConfigMap()
{
#ifdef VERBOSE_MEMORY
   cout << "HSConfigFile] created" << endl;
#endif
}

HSConfigFile::~HSConfigFile()
{
#ifdef VERBOSE_MEMORY
   cout << "HSConfigFile] destroyed" << endl;
#endif
}

bool
HSConfigFile::isSet( const string &entryName ) const
{
   const_iterator it = find( entryName );
   return it != end();
}

void
HSConfigFile::onParsedEntry( const string &l, const string &r )
{
   pair<iterator, bool> p = insert( make_pair<const string, string>( l, r ) );
   if( !p.second ) {
      cout << "Warning: " << l << " redefined." << endl;
      this->operator[]( l ) = r; // quick and dirty  ...
   }

#ifdef DEBUG
   cout << "HSConfigFile::onParsedEntry(): key=" << l << " value=" << r << '\'' << endl;
#endif
}
