
/***************************************************************************
                           hsircclient.hpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: hsircclient.cpp,v 1.9 2002/05/23 18:15:57 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <hsircclient.hpp>
#include <iostream>
#include "config.h"

HSIRCClient::HSIRCClient( const IRCToken& nickname, 
			  const IRCToken& username,
			  const IRCToken& address,
			  const IRCToken& realname,
			  const HSClient *hcl )
  : IRCClient( nickname, username, address, realname ),
    hsclient( hcl ),
    m_ircClientFlags( 0 )
{
#ifdef VERBOSE_MEMORY
  cout << "HSIRCClient] created" << endl;
#endif
}

HSIRCClient::~HSIRCClient()
{
#ifdef VERBOSE_MEMORY
  cout << "HSIRCClient] destroyed" << endl;
#endif
}

void
HSIRCClient::login( const HSClient* hscl )
{
   hsclient = hscl;
   
   setVHostApplied( hsclient->updateOnAuth() );
}

void HSIRCClient::logout()
{
   if( hsclient == NULL )
      return;

  // quick and dirty :/
  ( const_cast<HSClient*>( hsclient ) )->setOnline( false );

  hsclient = NULL;
}

ostream& operator<<( ostream& out, const HSIRCClient& client )
{
  return out << *client.getHSClient();
}
