#include "http_common.hpp"
#include "util.hpp"

/***************************************************************************
                           http_common.cpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: http_common.cpp,v 1.8 2002/05/25 16:15:36 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

namespace http
{

using std::ostream;

ostream& httpendl( ostream& out )
{ 
  out.put( HTTPTraits::CR );
  out.put( HTTPTraits::LF );
  
  return out; 
}

const HTTPString& 
httpProtocolVersionToString( httpprotversion_type ver )
{
   if( ver == HTTPVER_110 )
   {
	 static const HTTPString verStr( "HTTP/1.1" );
	 return verStr;
   }
   if( ver == HTTPVER_100 )
   {
      static const HTTPString verStr( "HTTP/1.0" );
      return verStr;
   }
   else
   {
      static const HTTPString verStr( "" );
      return verStr;
   }
}

httpresponseconnectiontype_type responseConnectionStringToType( const FieldValue& responseConnection )
{
   if( util::equalsIgnoreCase( responseConnection, FV_CONNECTION_KEEPALIVE ) )
      return HTTPCONN_KEEPALIVE;
   else if( util::equalsIgnoreCase( responseConnection, FV_CONNECTION_CLOSE ) )
     return HTTPCONN_CLOSE;

   return HTTPCONN_UNKNOWN;
}

}//EON http
