#include "httpserverport.hpp"
#include "httpclientconnection.hpp"
#include "config.h"

/***************************************************************************
                           httpserverport.cpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: httpserverport.cpp,v 1.6 2002/05/15 18:47:37 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

namespace httpd
{

HTTPServerPort::HTTPServerPort( HTTPd *server,
				Poller* poller,
				const InetHostAddress& bind,
				port_type port )
  : TCPPort( bind, port ),
    m_server( server ),
    m_poller( poller )
{
}

void
HTTPServerPort::onInput()
{
  // will call onConnected
  listen();
}

void
HTTPServerPort::onOutput()
{
  assert( false );
}

void
HTTPServerPort::onError()
{
#ifdef DEBUG
  cout << "HTTPServerPort::onError()" << endl;
#endif
}

void
HTTPServerPort::onHangup()
{
#ifdef DEBUG
  cout << "HTTPServerPort::onHangup(): hmpf?" << endl;
#endif
}

void
HTTPServerPort::onRemoved()
{
#ifdef DEBUG
  cout << "HTTPServerPort::onRemoved(): got removed from poller" << endl;
#endif
}

void
HTTPServerPort::onConnected( int sockFD,
			     const sockaddr_in& from,
			     socklen_t fromLen )
{
  m_server->addClientConnection( sockFD );
}

}//EON httpd
