#include "httptraits.hpp"

/***************************************************************************
                           httptraits.cpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: httptraits.cpp,v 1.3 2002/04/20 20:19:41 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


const HTTPTraits::chartype_type HTTPTraits::CHARTYPE_ATTRS[] =
{
   /* 0 */      CTL_C,
   /* 1 */      CTL_C,
   /* 2 */      CTL_C,
   /* 3 */      CTL_C,
   /* 4 */      CTL_C,
   /* 5 */      CTL_C,
   /* 6 */      CTL_C,
   /* 7 BEL */  CTL_C,
   /* 8 \b */   CTL_C,
   /* 9 \t */   CTL_C | SEPARA_C,
   /* 10 \n */  CTL_C,
   /* 11 \v */  CTL_C,
   /* 12 \f */  CTL_C,
   /* 13 \r */  CTL_C,
   /* 14 */     CTL_C,
   /* 15 */     CTL_C,
   /* 16 */     CTL_C,
   /* 17 */     CTL_C,
   /* 18 */     CTL_C,
   /* 19 */     CTL_C,
   /* 20 */     CTL_C,
   /* 21 */     CTL_C,
   /* 22 */     CTL_C,
   /* 23 */     CTL_C,
   /* 24 */     CTL_C,
   /* 25 */     CTL_C,
   /* 26 */     CTL_C,
   /* 27 */     CTL_C,
   /* 28 */     CTL_C,
   /* 29 */     CTL_C,
   /* 30 */     CTL_C,
   /* 31 */     CTL_C,
   /* SP */     SP_C | SEPARA_C | TEXT_C,
   /* !  */     TOKEN_C | TEXT_C,
   /* "  */     DQUOTE_C | TEXT_C,
   /* #  */     TOKEN_C | TEXT_C,
   /* $  */     TOKEN_C | TEXT_C,
   /* %  */     TOKEN_C | TEXT_C,
   /* &  */     TOKEN_C | TEXT_C,
   /* '  */     SQUOTE_C | TEXT_C,
   /* ( */      SEPARA_C | TEXT_C,
   /* ) */      SEPARA_C | TEXT_C,
   /* * */      TOKEN_C | TEXT_C,
   /* + */      TOKEN_C | TEXT_C,
   /* , */      SEPARA_C | TEXT_C,
   /* - */      TOKEN_C | TEXT_C,
   /* . */      TOKEN_C | TEXT_C,
   /* / */      SEPARA_C | TEXT_C,
   /* 0 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 1 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 2 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 3 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 4 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 5 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 6 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 7 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 8 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* 9 */      DIGIT_C | HEX_C | TOKEN_C | TEXT_C,
   /* : */      SEPARA_C | TEXT_C,
   /* ; */      SEPARA_C | TEXT_C,
   /* < */      SEPARA_C | TEXT_C,
   /* = */      SEPARA_C | TEXT_C,
   /* > */      SEPARA_C | TEXT_C,
   /* ? */      SEPARA_C | TEXT_C,
   /* @ */      SEPARA_C | TEXT_C,
   /* A */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* B */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* C */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* D */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* E */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* F */      UPALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* G */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* H */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* I */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* J */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* K */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* L */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* M */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* N */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* O */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* P */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* Q */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* R */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* S */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* T */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* U */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* V */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* W */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* X */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* Y */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* Z */      UPALPHA_C | TOKEN_C | TEXT_C,
   /* [ */      SEPARA_C | TEXT_C,
   /* \ */      SEPARA_C | TEXT_C,
   /* ] */      SEPARA_C | TEXT_C,
   /* ^ */      TOKEN_C | TEXT_C,
   /* _ */      TOKEN_C | TEXT_C,
   /* ` */      TOKEN_C | TEXT_C,
   /* a */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* b */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* c */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* d */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* e */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* f */      LOALPHA_C | HEX_C | TOKEN_C | TEXT_C,
   /* g */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* h */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* i */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* j */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* k */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* l */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* m */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* n */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* o */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* p */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* q */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* r */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* s */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* t */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* u */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* v */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* w */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* x */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* y */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* z */      LOALPHA_C | TOKEN_C | TEXT_C,
   /* { */      SEPARA_C | TEXT_C,
   /* | */      TOKEN_C | TEXT_C,
   /* } */      SEPARA_C | TEXT_C,
   /* ~ */      TOKEN_C | TEXT_C,
   /* del  */   CTL_C,
   /* 0x80 */   TOKEN_C | TEXT_C,
   /* 0x81 */   TOKEN_C | TEXT_C,
   /* 0x82 */   TOKEN_C | TEXT_C,
   /* 0x83 */   TOKEN_C | TEXT_C,
   /* 0x84 */   TOKEN_C | TEXT_C,
   /* 0x85 */   TOKEN_C | TEXT_C,
   /* 0x86 */   TOKEN_C | TEXT_C,
   /* 0x87 */   TOKEN_C | TEXT_C,
   /* 0x88 */   TOKEN_C | TEXT_C,
   /* 0x89 */   TOKEN_C | TEXT_C,
   /* 0x8A */   TOKEN_C | TEXT_C,
   /* 0x8B */   TOKEN_C | TEXT_C,
   /* 0x8C */   TOKEN_C | TEXT_C,
   /* 0x8D */   TOKEN_C | TEXT_C,
   /* 0x8E */   TOKEN_C | TEXT_C,
   /* 0x8F */   TOKEN_C | TEXT_C,
   /* 0x90 */   TOKEN_C | TEXT_C,
   /* 0x91 */   TOKEN_C | TEXT_C,
   /* 0x92 */   TOKEN_C | TEXT_C,
   /* 0x93 */   TOKEN_C | TEXT_C,
   /* 0x94 */   TOKEN_C | TEXT_C,
   /* 0x95 */   TOKEN_C | TEXT_C,
   /* 0x96 */   TOKEN_C | TEXT_C,
   /* 0x97 */   TOKEN_C | TEXT_C,
   /* 0x98 */   TOKEN_C | TEXT_C,
   /* 0x99 */   TOKEN_C | TEXT_C,
   /* 0x9A */   TOKEN_C | TEXT_C,
   /* 0x9B */   TOKEN_C | TEXT_C,
   /* 0x9C */   TOKEN_C | TEXT_C,
   /* 0x9D */   TOKEN_C | TEXT_C,
   /* 0x9E */   TOKEN_C | TEXT_C,
   /* 0x9F */   TOKEN_C | TEXT_C,
   /* 0xA0 */   TOKEN_C | TEXT_C,
   /* 0xA1 */   TOKEN_C | TEXT_C,
   /* 0xA2 */   TOKEN_C | TEXT_C,
   /* 0xA3 */   TOKEN_C | TEXT_C,
   /* 0xA4 */   TOKEN_C | TEXT_C,
   /* 0xA5 */   TOKEN_C | TEXT_C,
   /* 0xA6 */   TOKEN_C | TEXT_C,
   /* 0xA7 */   TOKEN_C | TEXT_C,
   /* 0xA8 */   TOKEN_C | TEXT_C,
   /* 0xA9 */   TOKEN_C | TEXT_C,
   /* 0xAA */   TOKEN_C | TEXT_C,
   /* 0xAB */   TOKEN_C | TEXT_C,
   /* 0xAC */   TOKEN_C | TEXT_C,
   /* 0xAD */   TOKEN_C | TEXT_C,
   /* 0xAE */   TOKEN_C | TEXT_C,
   /* 0xAF */   TOKEN_C | TEXT_C,
   /* 0xB0 */   TOKEN_C | TEXT_C,
   /* 0xB1 */   TOKEN_C | TEXT_C,
   /* 0xB2 */   TOKEN_C | TEXT_C,
   /* 0xB3 */   TOKEN_C | TEXT_C,
   /* 0xB4 */   TOKEN_C | TEXT_C,
   /* 0xB5 */   TOKEN_C | TEXT_C,
   /* 0xB6 */   TOKEN_C | TEXT_C,
   /* 0xB7 */   TOKEN_C | TEXT_C,
   /* 0xB8 */   TOKEN_C | TEXT_C,
   /* 0xB9 */   TOKEN_C | TEXT_C,
   /* 0xBA */   TOKEN_C | TEXT_C,
   /* 0xBB */   TOKEN_C | TEXT_C,
   /* 0xBC */   TOKEN_C | TEXT_C,
   /* 0xBD */   TOKEN_C | TEXT_C,
   /* 0xBE */   TOKEN_C | TEXT_C,
   /* 0xBF */   TOKEN_C | TEXT_C,
   /* 0xC0 */   TOKEN_C | TEXT_C,
   /* 0xC1 */   TOKEN_C | TEXT_C,
   /* 0xC2 */   TOKEN_C | TEXT_C,
   /* 0xC3 */   TOKEN_C | TEXT_C,
   /* 0xC4 */   TOKEN_C | TEXT_C,
   /* 0xC5 */   TOKEN_C | TEXT_C,
   /* 0xC6 */   TOKEN_C | TEXT_C,
   /* 0xC7 */   TOKEN_C | TEXT_C,
   /* 0xC8 */   TOKEN_C | TEXT_C,
   /* 0xC9 */   TOKEN_C | TEXT_C,
   /* 0xCA */   TOKEN_C | TEXT_C,
   /* 0xCB */   TOKEN_C | TEXT_C,
   /* 0xCC */   TOKEN_C | TEXT_C,
   /* 0xCD */   TOKEN_C | TEXT_C,
   /* 0xCE */   TOKEN_C | TEXT_C,
   /* 0xCF */   TOKEN_C | TEXT_C,
   /* 0xD0 */   TOKEN_C | TEXT_C,
   /* 0xD1 */   TOKEN_C | TEXT_C,
   /* 0xD2 */   TOKEN_C | TEXT_C,
   /* 0xD3 */   TOKEN_C | TEXT_C,
   /* 0xD4 */   TOKEN_C | TEXT_C,
   /* 0xD5 */   TOKEN_C | TEXT_C,
   /* 0xD6 */   TOKEN_C | TEXT_C,
   /* 0xD7 */   TOKEN_C | TEXT_C,
   /* 0xD8 */   TOKEN_C | TEXT_C,
   /* 0xD9 */   TOKEN_C | TEXT_C,
   /* 0xDA */   TOKEN_C | TEXT_C,
   /* 0xDB */   TOKEN_C | TEXT_C,
   /* 0xDC */   TOKEN_C | TEXT_C,
   /* 0xDD */   TOKEN_C | TEXT_C,
   /* 0xDE */   TOKEN_C | TEXT_C,
   /* 0xDF */   TOKEN_C | TEXT_C,
   /* 0xE0 */   TOKEN_C | TEXT_C,
   /* 0xE1 */   TOKEN_C | TEXT_C,
   /* 0xE2 */   TOKEN_C | TEXT_C,
   /* 0xE3 */   TOKEN_C | TEXT_C,
   /* 0xE4 */   TOKEN_C | TEXT_C,
   /* 0xE5 */   TOKEN_C | TEXT_C,
   /* 0xE6 */   TOKEN_C | TEXT_C,
   /* 0xE7 */   TOKEN_C | TEXT_C,
   /* 0xE8 */   TOKEN_C | TEXT_C,
   /* 0xE9 */   TOKEN_C | TEXT_C,
   /* 0xEA */   TOKEN_C | TEXT_C,
   /* 0xEB */   TOKEN_C | TEXT_C,
   /* 0xEC */   TOKEN_C | TEXT_C,
   /* 0xED */   TOKEN_C | TEXT_C,
   /* 0xEE */   TOKEN_C | TEXT_C,
   /* 0xEF */   TOKEN_C | TEXT_C,
   /* 0xF0 */   TOKEN_C | TEXT_C,
   /* 0xF1 */   TOKEN_C | TEXT_C,
   /* 0xF2 */   TOKEN_C | TEXT_C,
   /* 0xF3 */   TOKEN_C | TEXT_C,
   /* 0xF4 */   TOKEN_C | TEXT_C,
   /* 0xF5 */   TOKEN_C | TEXT_C,
   /* 0xF6 */   TOKEN_C | TEXT_C,
   /* 0xF7 */   TOKEN_C | TEXT_C,
   /* 0xF8 */   TOKEN_C | TEXT_C,
   /* 0xF9 */   TOKEN_C | TEXT_C,
   /* 0xFA */   TOKEN_C | TEXT_C,
   /* 0xFB */   TOKEN_C | TEXT_C,
   /* 0xFC */   TOKEN_C | TEXT_C,
   /* 0xFD */   TOKEN_C | TEXT_C,
   /* 0xFE */   TOKEN_C | TEXT_C,
   /* 0xFF */   TOKEN_C | TEXT_C
};

