/***************************************************************************
                           inethostaddress.cpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: inethostaddress.cpp,v 1.8 2002/05/25 16:15:36 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

extern "C" {
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
}
#include <inethostaddress.hpp>
#include <cstdio>
#include <iostream>

using std::ostream;
using std::string;

ostream&
operator<< (ostream &outs, const InetHostAddress &addr)
{
  outs << addr.getHostent()->h_name;
  return outs;
}

InetHostAddress::InetHostAddress() : he(NULL)
{
}

InetHostAddress::InetHostAddress( const char *name )
{
  init( name );
}

InetHostAddress::InetHostAddress( const string &name )
{
  init( name.c_str() );
}

bool
InetHostAddress::operator! () const
{
  return he == NULL; 
}

InetHostAddress::operator void* () const
{
  return he;
}

void
InetHostAddress::init(const char *name)
{
  he=gethostbyname( name );
}

const
InetHostAddress & InetHostAddress::operator=( const char *name )
{
//   if( he ) 
//     free( he );
  init( name );
  return *this;
}

const
InetHostAddress & InetHostAddress::operator= ( const string &name )
{
//   if( he ) 
//     free( he );
  init( name.c_str() );
  return *this;
}
