/***************************************************************************
                           ircclient.cpp
                           -------------------
    copyright            : (C) 2001,2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: ircclient.cpp,v 1.8 2002/03/09 12:49:34 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <ircclient.hpp>
#include <iostream>

IRCClient::IRCClient( const IRCToken& nick,
		      const IRCToken& username,
		      const IRCToken& address,
		      const IRCToken& realname )
  : m_nickname( nick ),
    m_username( username ),
    m_address( address ),
    m_realname( realname )
{
#ifdef VERBOSE_MEMORY
  cout << "IRCClient] created: " << nick << '!' << username 
       << '@' << address << ':' << realname << endl;
#endif
}

IRCClient::~IRCClient()
{
#ifdef VERBOSE_MEMORY
  cout << "IRCClient] destroyed (" << m_nickname << ")" << endl;
#endif
}

void IRCClient::setNickname(const IRCToken &newNick) 
{
#ifdef DEBUG
  cout << "IRCClient] setting new nickname: " << m_nickname << "->" << newNick << "... ";
#endif

  m_nickname=newNick;
  cout << "done" << endl;
}
