/***************************************************************************
                           ircfileinbuf.cpp
                           -------------------
    copyright            : (C) 2002 by Martin Scholl
    email                : ms@deridiot.net

    $Id: ircfileinbuf.cpp,v 1.7 2002/04/10 18:21:48 d3cline Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "ircfileinbuf.hpp"

IRCFileInBuf::IRCFileInBuf( File& f, 
			    len_type buflen,
			    int maxMsgArgs )
   : FileInBuf( f, buflen ),
     m_tokenizer( maxMsgArgs )
{ 
}

const IRCServerMessage*
IRCFileInBuf::read( data_reference buf, len_type len )
{
   if( stateEof() ) return NULL;

   data_reference       readPos      = FileInBuf::getReadPos();
   const data_reference readMax      = FileInBuf::getReadMax();
   const int_type       tokenizedLen = m_tokenizer.update( readPos, readMax - readPos );

   if( tokenizedLen != -1 )
   {
      // +1 -> skip '\n' 
      FileInBuf::setReadPos( readPos + tokenizedLen + 1 );
      return &m_tokenizer.getMessage();
   }
   else 
      return NULL;
}
