#include "messageheader.hpp"
#include "http_common.hpp"
#include "config.h"

namespace http
{
   const MessageHeader MessageHeader::ChunkedTransferEncoding( GENERAL_TRANSFER_ENCODING,
							       FV_TE_CHUNKED );
   const MessageHeader MessageHeader::ConnectionClose( GENERAL_CONNECTION,
						       FV_CONNECTION_CLOSE );
   
   const MessageHeader MessageHeader::ConnectionKeepAlive( GENERAL_CONNECTION,
							   FV_CONNECTION_KEEPALIVE );
   
   const MessageHeader MessageHeader::Server( RESP_SERVER, "HostServ/" VERSION );
   
   const MessageHeader MessageHeader::AcceptRanges( ENT_ACCEPT_RANGES, FV_BYTES );
   
   const MessageHeader MessageHeader::PlainTextContentType( ENT_CONTENT_TYPE, "text/plain" );
   
}
