#include "responsestatusline.hpp"

namespace http
{

const ResponseStatusline::ResponseValueString ResponseStatusline::RESPONSE_TAB[] = 
{
   { 100,  "CONTINUE"                       },
   { 101,  "Switching Protocols"            },
   { 200,  "OK"                             },
   { 201,  "Created"                        },
   { 202,  "Accepted"                       },
   { 203,  "Non-Authorative Information"    },
   { 204,  "No Content"                     },
   { 205,  "Reset Content"                  },
   { 206,  "Partial Content"                },
   { 300,  "Multiple Choices"               },
   { 301,  "Moved permanentely"             },
   { 302,  "Found"                          },
   { 303,  "See other"                      },
   { 304,  "Not modified"                   },
   { 305,  "Use proxy"                      },
   { 307,  "Temporary Redirect"             },
   { 400,  "Bad request"                    },
   { 401,  "Unauthorized"                   },
   { 402,  "Payment required"               },
   { 403,  "Forbidden"                      },
   { 404,  "Not Found"                      },
   { 405,  "Method Not Allowed"             },
   { 406,  "Not acceptable"                 },
   { 407,  "Proxy Authentication Required"  },
   { 408,  "Request Time-out"               },
   { 409,  "Conflict"                       },
   { 410,  "Gone"                           },
   { 411,  "Length required"                },
   { 412,  "Precondition Failed"            },
   { 413,  "Request Entity Too Large"       },
   { 414,  "Request URI Too Large"          },
   { 415,  "Unsupporeted Media Type"        },
   { 416,  "Requestd Range Not Satisfiable" },
   { 417,  "Expectation Failed"             },
   { 500,  "Internal Server Error"          },
   { 501,  "Not Implemented"                },
   { 502,  "Bad Gateway"                    },
   { 503,  "Service Unavailable"            },
   { 504,  "Gateway Time-out"               },
   { 505,  "HTTP Version not supported"     }
};

std::ostream&
operator<<( std::ostream& out, 
	    const ResponseStatusline& statusLine )
{
   return out << httpProtocolVersionToString( statusLine.getProtocolVersion() )
	      << HTTPTraits::WS
	      << statusLine.getResponseCode()
	      << HTTPTraits::WS
	      << statusLine.getReason();
}

}
